#include <stdio.h>
#include <stdint.h>

uint8_t and_gate(uint8_t _a, uint8_t _b){
  return ((_a >> 0) & 0x01) & ((_b >> 0) & 0x01);
}

uint8_t xor_gate(uint8_t _a, uint8_t _b){
  return ((_a >> 0) & 0x01) ^ ((_b >> 0) & 0x01);
}

uint8_t or_gate(uint8_t _a, uint8_t _b){
  return ((_a >> 0) & 0x01) | ((_b >> 0) & 0x01);
}

uint8_t ha(uint8_t a, uint8_t b){
  uint8_t out = 0;
  out |= (xor_gate(a, b) & 0x01) << 0;
  out |= (and_gate(a, b) & 0x01) << 1;
  return out;
}

uint8_t fa(uint8_t a, uint8_t b, uint8_t cin){
  uint8_t out = 0;
  uint8_t fa_y0 = 0;
  uint8_t fa_y1 = 0;
  uint8_t fa_y3 = 0;

  fa_y0 = xor_gate(a, b);
  fa_y1 = and_gate(a, b);
  fa_y3 = and_gate(fa_y0, cin);

  out |= (xor_gate(fa_y0, cin) & 0x01) << 0;
  out |= (or_gate(fa_y1, fa_y3) & 0x01) << 1;
  return out;
}

uint64_t u_rca10(uint64_t a, uint64_t b){
  uint64_t out = 0;
  uint8_t a_0 = 0;
  uint8_t a_1 = 0;
  uint8_t a_2 = 0;
  uint8_t a_3 = 0;
  uint8_t a_4 = 0;
  uint8_t a_5 = 0;
  uint8_t a_6 = 0;
  uint8_t a_7 = 0;
  uint8_t a_8 = 0;
  uint8_t a_9 = 0;
  uint8_t b_0 = 0;
  uint8_t b_1 = 0;
  uint8_t b_2 = 0;
  uint8_t b_3 = 0;
  uint8_t b_4 = 0;
  uint8_t b_5 = 0;
  uint8_t b_6 = 0;
  uint8_t b_7 = 0;
  uint8_t b_8 = 0;
  uint8_t b_9 = 0;
  uint8_t u_rca10_ha_y0 = 0;
  uint8_t u_rca10_ha_y1 = 0;
  uint8_t u_rca10_fa1_y2 = 0;
  uint8_t u_rca10_fa1_y4 = 0;
  uint8_t u_rca10_fa2_y2 = 0;
  uint8_t u_rca10_fa2_y4 = 0;
  uint8_t u_rca10_fa3_y2 = 0;
  uint8_t u_rca10_fa3_y4 = 0;
  uint8_t u_rca10_fa4_y2 = 0;
  uint8_t u_rca10_fa4_y4 = 0;
  uint8_t u_rca10_fa5_y2 = 0;
  uint8_t u_rca10_fa5_y4 = 0;
  uint8_t u_rca10_fa6_y2 = 0;
  uint8_t u_rca10_fa6_y4 = 0;
  uint8_t u_rca10_fa7_y2 = 0;
  uint8_t u_rca10_fa7_y4 = 0;
  uint8_t u_rca10_fa8_y2 = 0;
  uint8_t u_rca10_fa8_y4 = 0;
  uint8_t u_rca10_fa9_y2 = 0;
  uint8_t u_rca10_fa9_y4 = 0;

  a_0 = ((a >> 0) & 0x01);
  a_1 = ((a >> 1) & 0x01);
  a_2 = ((a >> 2) & 0x01);
  a_3 = ((a >> 3) & 0x01);
  a_4 = ((a >> 4) & 0x01);
  a_5 = ((a >> 5) & 0x01);
  a_6 = ((a >> 6) & 0x01);
  a_7 = ((a >> 7) & 0x01);
  a_8 = ((a >> 8) & 0x01);
  a_9 = ((a >> 9) & 0x01);
  b_0 = ((b >> 0) & 0x01);
  b_1 = ((b >> 1) & 0x01);
  b_2 = ((b >> 2) & 0x01);
  b_3 = ((b >> 3) & 0x01);
  b_4 = ((b >> 4) & 0x01);
  b_5 = ((b >> 5) & 0x01);
  b_6 = ((b >> 6) & 0x01);
  b_7 = ((b >> 7) & 0x01);
  b_8 = ((b >> 8) & 0x01);
  b_9 = ((b >> 9) & 0x01);
  u_rca10_ha_y0 = (ha(a_0, b_0) >> 0) & 0x01;
  u_rca10_ha_y1 = (ha(a_0, b_0) >> 1) & 0x01;
  u_rca10_fa1_y2 = (fa(a_1, b_1, u_rca10_ha_y1) >> 0) & 0x01;
  u_rca10_fa1_y4 = (fa(a_1, b_1, u_rca10_ha_y1) >> 1) & 0x01;
  u_rca10_fa2_y2 = (fa(a_2, b_2, u_rca10_fa1_y4) >> 0) & 0x01;
  u_rca10_fa2_y4 = (fa(a_2, b_2, u_rca10_fa1_y4) >> 1) & 0x01;
  u_rca10_fa3_y2 = (fa(a_3, b_3, u_rca10_fa2_y4) >> 0) & 0x01;
  u_rca10_fa3_y4 = (fa(a_3, b_3, u_rca10_fa2_y4) >> 1) & 0x01;
  u_rca10_fa4_y2 = (fa(a_4, b_4, u_rca10_fa3_y4) >> 0) & 0x01;
  u_rca10_fa4_y4 = (fa(a_4, b_4, u_rca10_fa3_y4) >> 1) & 0x01;
  u_rca10_fa5_y2 = (fa(a_5, b_5, u_rca10_fa4_y4) >> 0) & 0x01;
  u_rca10_fa5_y4 = (fa(a_5, b_5, u_rca10_fa4_y4) >> 1) & 0x01;
  u_rca10_fa6_y2 = (fa(a_6, b_6, u_rca10_fa5_y4) >> 0) & 0x01;
  u_rca10_fa6_y4 = (fa(a_6, b_6, u_rca10_fa5_y4) >> 1) & 0x01;
  u_rca10_fa7_y2 = (fa(a_7, b_7, u_rca10_fa6_y4) >> 0) & 0x01;
  u_rca10_fa7_y4 = (fa(a_7, b_7, u_rca10_fa6_y4) >> 1) & 0x01;
  u_rca10_fa8_y2 = (fa(a_8, b_8, u_rca10_fa7_y4) >> 0) & 0x01;
  u_rca10_fa8_y4 = (fa(a_8, b_8, u_rca10_fa7_y4) >> 1) & 0x01;
  u_rca10_fa9_y2 = (fa(a_9, b_9, u_rca10_fa8_y4) >> 0) & 0x01;
  u_rca10_fa9_y4 = (fa(a_9, b_9, u_rca10_fa8_y4) >> 1) & 0x01;

  out |= (u_rca10_ha_y0 & 0x01) << 0;
  out |= (u_rca10_fa1_y2 & 0x01) << 1;
  out |= (u_rca10_fa2_y2 & 0x01) << 2;
  out |= (u_rca10_fa3_y2 & 0x01) << 3;
  out |= (u_rca10_fa4_y2 & 0x01) << 4;
  out |= (u_rca10_fa5_y2 & 0x01) << 5;
  out |= (u_rca10_fa6_y2 & 0x01) << 6;
  out |= (u_rca10_fa7_y2 & 0x01) << 7;
  out |= (u_rca10_fa8_y2 & 0x01) << 8;
  out |= (u_rca10_fa9_y2 & 0x01) << 9;
  out |= (u_rca10_fa9_y4 & 0x01) << 10;
  return out;
}

uint64_t h_u_dadda_mul6(uint64_t a, uint64_t b){
  uint64_t out = 0;
  uint8_t a_0 = 0;
  uint8_t a_1 = 0;
  uint8_t a_2 = 0;
  uint8_t a_3 = 0;
  uint8_t a_4 = 0;
  uint8_t a_5 = 0;
  uint8_t b_0 = 0;
  uint8_t b_1 = 0;
  uint8_t b_2 = 0;
  uint8_t b_3 = 0;
  uint8_t b_4 = 0;
  uint8_t b_5 = 0;
  uint8_t h_u_dadda_mul6_and_4_0_y0 = 0;
  uint8_t h_u_dadda_mul6_and_3_1_y0 = 0;
  uint8_t h_u_dadda_mul6_ha0_y0 = 0;
  uint8_t h_u_dadda_mul6_ha0_y1 = 0;
  uint8_t h_u_dadda_mul6_and_5_0_y0 = 0;
  uint8_t h_u_dadda_mul6_and_4_1_y0 = 0;
  uint8_t h_u_dadda_mul6_fa0_y2 = 0;
  uint8_t h_u_dadda_mul6_fa0_y4 = 0;
  uint8_t h_u_dadda_mul6_and_3_2_y0 = 0;
  uint8_t h_u_dadda_mul6_and_2_3_y0 = 0;
  uint8_t h_u_dadda_mul6_ha1_y0 = 0;
  uint8_t h_u_dadda_mul6_ha1_y1 = 0;
  uint8_t h_u_dadda_mul6_and_5_1_y0 = 0;
  uint8_t h_u_dadda_mul6_fa1_y2 = 0;
  uint8_t h_u_dadda_mul6_fa1_y4 = 0;
  uint8_t h_u_dadda_mul6_and_4_2_y0 = 0;
  uint8_t h_u_dadda_mul6_and_3_3_y0 = 0;
  uint8_t h_u_dadda_mul6_ha2_y0 = 0;
  uint8_t h_u_dadda_mul6_ha2_y1 = 0;
  uint8_t h_u_dadda_mul6_and_5_2_y0 = 0;
  uint8_t h_u_dadda_mul6_fa2_y2 = 0;
  uint8_t h_u_dadda_mul6_fa2_y4 = 0;
  uint8_t h_u_dadda_mul6_and_2_0_y0 = 0;
  uint8_t h_u_dadda_mul6_and_1_1_y0 = 0;
  uint8_t h_u_dadda_mul6_ha3_y0 = 0;
  uint8_t h_u_dadda_mul6_ha3_y1 = 0;
  uint8_t h_u_dadda_mul6_and_3_0_y0 = 0;
  uint8_t h_u_dadda_mul6_and_2_1_y0 = 0;
  uint8_t h_u_dadda_mul6_fa3_y2 = 0;
  uint8_t h_u_dadda_mul6_fa3_y4 = 0;
  uint8_t h_u_dadda_mul6_and_1_2_y0 = 0;
  uint8_t h_u_dadda_mul6_and_0_3_y0 = 0;
  uint8_t h_u_dadda_mul6_ha4_y0 = 0;
  uint8_t h_u_dadda_mul6_ha4_y1 = 0;
  uint8_t h_u_dadda_mul6_and_2_2_y0 = 0;
  uint8_t h_u_dadda_mul6_fa4_y2 = 0;
  uint8_t h_u_dadda_mul6_fa4_y4 = 0;
  uint8_t h_u_dadda_mul6_and_1_3_y0 = 0;
  uint8_t h_u_dadda_mul6_and_0_4_y0 = 0;
  uint8_t h_u_dadda_mul6_fa5_y2 = 0;
  uint8_t h_u_dadda_mul6_fa5_y4 = 0;
  uint8_t h_u_dadda_mul6_and_1_4_y0 = 0;
  uint8_t h_u_dadda_mul6_fa6_y2 = 0;
  uint8_t h_u_dadda_mul6_fa6_y4 = 0;
  uint8_t h_u_dadda_mul6_and_0_5_y0 = 0;
  uint8_t h_u_dadda_mul6_fa7_y2 = 0;
  uint8_t h_u_dadda_mul6_fa7_y4 = 0;
  uint8_t h_u_dadda_mul6_and_2_4_y0 = 0;
  uint8_t h_u_dadda_mul6_fa8_y2 = 0;
  uint8_t h_u_dadda_mul6_fa8_y4 = 0;
  uint8_t h_u_dadda_mul6_and_1_5_y0 = 0;
  uint8_t h_u_dadda_mul6_fa9_y2 = 0;
  uint8_t h_u_dadda_mul6_fa9_y4 = 0;
  uint8_t h_u_dadda_mul6_and_4_3_y0 = 0;
  uint8_t h_u_dadda_mul6_fa10_y2 = 0;
  uint8_t h_u_dadda_mul6_fa10_y4 = 0;
  uint8_t h_u_dadda_mul6_and_3_4_y0 = 0;
  uint8_t h_u_dadda_mul6_and_2_5_y0 = 0;
  uint8_t h_u_dadda_mul6_fa11_y2 = 0;
  uint8_t h_u_dadda_mul6_fa11_y4 = 0;
  uint8_t h_u_dadda_mul6_fa12_y2 = 0;
  uint8_t h_u_dadda_mul6_fa12_y4 = 0;
  uint8_t h_u_dadda_mul6_and_5_3_y0 = 0;
  uint8_t h_u_dadda_mul6_and_4_4_y0 = 0;
  uint8_t h_u_dadda_mul6_and_3_5_y0 = 0;
  uint8_t h_u_dadda_mul6_fa13_y2 = 0;
  uint8_t h_u_dadda_mul6_fa13_y4 = 0;
  uint8_t h_u_dadda_mul6_and_5_4_y0 = 0;
  uint8_t h_u_dadda_mul6_fa14_y2 = 0;
  uint8_t h_u_dadda_mul6_fa14_y4 = 0;
  uint8_t h_u_dadda_mul6_and_0_0_y0 = 0;
  uint8_t h_u_dadda_mul6_and_1_0_y0 = 0;
  uint8_t h_u_dadda_mul6_and_0_2_y0 = 0;
  uint8_t h_u_dadda_mul6_and_4_5_y0 = 0;
  uint8_t h_u_dadda_mul6_and_0_1_y0 = 0;
  uint8_t h_u_dadda_mul6_and_5_5_y0 = 0;
  uint64_t h_u_dadda_mul6_u_rca10_rca_a = 0;
  uint64_t h_u_dadda_mul6_u_rca10_rca_b = 0;
  uint64_t h_u_dadda_mul6_u_rca10_out = 0;
  uint8_t h_u_dadda_mul6_u_rca10_ha_y0 = 0;
  uint8_t h_u_dadda_mul6_u_rca10_fa1_y2 = 0;
  uint8_t h_u_dadda_mul6_u_rca10_fa2_y2 = 0;
  uint8_t h_u_dadda_mul6_u_rca10_fa3_y2 = 0;
  uint8_t h_u_dadda_mul6_u_rca10_fa4_y2 = 0;
  uint8_t h_u_dadda_mul6_u_rca10_fa5_y2 = 0;
  uint8_t h_u_dadda_mul6_u_rca10_fa6_y2 = 0;
  uint8_t h_u_dadda_mul6_u_rca10_fa7_y2 = 0;
  uint8_t h_u_dadda_mul6_u_rca10_fa8_y2 = 0;
  uint8_t h_u_dadda_mul6_u_rca10_fa9_y2 = 0;
  uint8_t h_u_dadda_mul6_u_rca10_fa9_y4 = 0;

  a_0 = ((a >> 0) & 0x01);
  a_1 = ((a >> 1) & 0x01);
  a_2 = ((a >> 2) & 0x01);
  a_3 = ((a >> 3) & 0x01);
  a_4 = ((a >> 4) & 0x01);
  a_5 = ((a >> 5) & 0x01);
  b_0 = ((b >> 0) & 0x01);
  b_1 = ((b >> 1) & 0x01);
  b_2 = ((b >> 2) & 0x01);
  b_3 = ((b >> 3) & 0x01);
  b_4 = ((b >> 4) & 0x01);
  b_5 = ((b >> 5) & 0x01);
  h_u_dadda_mul6_and_4_0_y0 = and_gate(a_4, b_0);
  h_u_dadda_mul6_and_3_1_y0 = and_gate(a_3, b_1);
  h_u_dadda_mul6_ha0_y0 = (ha(h_u_dadda_mul6_and_4_0_y0, h_u_dadda_mul6_and_3_1_y0) >> 0) & 0x01;
  h_u_dadda_mul6_ha0_y1 = (ha(h_u_dadda_mul6_and_4_0_y0, h_u_dadda_mul6_and_3_1_y0) >> 1) & 0x01;
  h_u_dadda_mul6_and_5_0_y0 = and_gate(a_5, b_0);
  h_u_dadda_mul6_and_4_1_y0 = and_gate(a_4, b_1);
  h_u_dadda_mul6_fa0_y2 = (fa(h_u_dadda_mul6_ha0_y1, h_u_dadda_mul6_and_5_0_y0, h_u_dadda_mul6_and_4_1_y0) >> 0) & 0x01;
  h_u_dadda_mul6_fa0_y4 = (fa(h_u_dadda_mul6_ha0_y1, h_u_dadda_mul6_and_5_0_y0, h_u_dadda_mul6_and_4_1_y0) >> 1) & 0x01;
  h_u_dadda_mul6_and_3_2_y0 = and_gate(a_3, b_2);
  h_u_dadda_mul6_and_2_3_y0 = and_gate(a_2, b_3);
  h_u_dadda_mul6_ha1_y0 = (ha(h_u_dadda_mul6_and_3_2_y0, h_u_dadda_mul6_and_2_3_y0) >> 0) & 0x01;
  h_u_dadda_mul6_ha1_y1 = (ha(h_u_dadda_mul6_and_3_2_y0, h_u_dadda_mul6_and_2_3_y0) >> 1) & 0x01;
  h_u_dadda_mul6_and_5_1_y0 = and_gate(a_5, b_1);
  h_u_dadda_mul6_fa1_y2 = (fa(h_u_dadda_mul6_ha1_y1, h_u_dadda_mul6_fa0_y4, h_u_dadda_mul6_and_5_1_y0) >> 0) & 0x01;
  h_u_dadda_mul6_fa1_y4 = (fa(h_u_dadda_mul6_ha1_y1, h_u_dadda_mul6_fa0_y4, h_u_dadda_mul6_and_5_1_y0) >> 1) & 0x01;
  h_u_dadda_mul6_and_4_2_y0 = and_gate(a_4, b_2);
  h_u_dadda_mul6_and_3_3_y0 = and_gate(a_3, b_3);
  h_u_dadda_mul6_ha2_y0 = (ha(h_u_dadda_mul6_and_4_2_y0, h_u_dadda_mul6_and_3_3_y0) >> 0) & 0x01;
  h_u_dadda_mul6_ha2_y1 = (ha(h_u_dadda_mul6_and_4_2_y0, h_u_dadda_mul6_and_3_3_y0) >> 1) & 0x01;
  h_u_dadda_mul6_and_5_2_y0 = and_gate(a_5, b_2);
  h_u_dadda_mul6_fa2_y2 = (fa(h_u_dadda_mul6_ha2_y1, h_u_dadda_mul6_fa1_y4, h_u_dadda_mul6_and_5_2_y0) >> 0) & 0x01;
  h_u_dadda_mul6_fa2_y4 = (fa(h_u_dadda_mul6_ha2_y1, h_u_dadda_mul6_fa1_y4, h_u_dadda_mul6_and_5_2_y0) >> 1) & 0x01;
  h_u_dadda_mul6_and_2_0_y0 = and_gate(a_2, b_0);
  h_u_dadda_mul6_and_1_1_y0 = and_gate(a_1, b_1);
  h_u_dadda_mul6_ha3_y0 = (ha(h_u_dadda_mul6_and_2_0_y0, h_u_dadda_mul6_and_1_1_y0) >> 0) & 0x01;
  h_u_dadda_mul6_ha3_y1 = (ha(h_u_dadda_mul6_and_2_0_y0, h_u_dadda_mul6_and_1_1_y0) >> 1) & 0x01;
  h_u_dadda_mul6_and_3_0_y0 = and_gate(a_3, b_0);
  h_u_dadda_mul6_and_2_1_y0 = and_gate(a_2, b_1);
  h_u_dadda_mul6_fa3_y2 = (fa(h_u_dadda_mul6_ha3_y1, h_u_dadda_mul6_and_3_0_y0, h_u_dadda_mul6_and_2_1_y0) >> 0) & 0x01;
  h_u_dadda_mul6_fa3_y4 = (fa(h_u_dadda_mul6_ha3_y1, h_u_dadda_mul6_and_3_0_y0, h_u_dadda_mul6_and_2_1_y0) >> 1) & 0x01;
  h_u_dadda_mul6_and_1_2_y0 = and_gate(a_1, b_2);
  h_u_dadda_mul6_and_0_3_y0 = and_gate(a_0, b_3);
  h_u_dadda_mul6_ha4_y0 = (ha(h_u_dadda_mul6_and_1_2_y0, h_u_dadda_mul6_and_0_3_y0) >> 0) & 0x01;
  h_u_dadda_mul6_ha4_y1 = (ha(h_u_dadda_mul6_and_1_2_y0, h_u_dadda_mul6_and_0_3_y0) >> 1) & 0x01;
  h_u_dadda_mul6_and_2_2_y0 = and_gate(a_2, b_2);
  h_u_dadda_mul6_fa4_y2 = (fa(h_u_dadda_mul6_ha4_y1, h_u_dadda_mul6_fa3_y4, h_u_dadda_mul6_and_2_2_y0) >> 0) & 0x01;
  h_u_dadda_mul6_fa4_y4 = (fa(h_u_dadda_mul6_ha4_y1, h_u_dadda_mul6_fa3_y4, h_u_dadda_mul6_and_2_2_y0) >> 1) & 0x01;
  h_u_dadda_mul6_and_1_3_y0 = and_gate(a_1, b_3);
  h_u_dadda_mul6_and_0_4_y0 = and_gate(a_0, b_4);
  h_u_dadda_mul6_fa5_y2 = (fa(h_u_dadda_mul6_and_1_3_y0, h_u_dadda_mul6_and_0_4_y0, h_u_dadda_mul6_ha0_y0) >> 0) & 0x01;
  h_u_dadda_mul6_fa5_y4 = (fa(h_u_dadda_mul6_and_1_3_y0, h_u_dadda_mul6_and_0_4_y0, h_u_dadda_mul6_ha0_y0) >> 1) & 0x01;
  h_u_dadda_mul6_and_1_4_y0 = and_gate(a_1, b_4);
  h_u_dadda_mul6_fa6_y2 = (fa(h_u_dadda_mul6_fa5_y4, h_u_dadda_mul6_fa4_y4, h_u_dadda_mul6_and_1_4_y0) >> 0) & 0x01;
  h_u_dadda_mul6_fa6_y4 = (fa(h_u_dadda_mul6_fa5_y4, h_u_dadda_mul6_fa4_y4, h_u_dadda_mul6_and_1_4_y0) >> 1) & 0x01;
  h_u_dadda_mul6_and_0_5_y0 = and_gate(a_0, b_5);
  h_u_dadda_mul6_fa7_y2 = (fa(h_u_dadda_mul6_and_0_5_y0, h_u_dadda_mul6_fa0_y2, h_u_dadda_mul6_ha1_y0) >> 0) & 0x01;
  h_u_dadda_mul6_fa7_y4 = (fa(h_u_dadda_mul6_and_0_5_y0, h_u_dadda_mul6_fa0_y2, h_u_dadda_mul6_ha1_y0) >> 1) & 0x01;
  h_u_dadda_mul6_and_2_4_y0 = and_gate(a_2, b_4);
  h_u_dadda_mul6_fa8_y2 = (fa(h_u_dadda_mul6_fa7_y4, h_u_dadda_mul6_fa6_y4, h_u_dadda_mul6_and_2_4_y0) >> 0) & 0x01;
  h_u_dadda_mul6_fa8_y4 = (fa(h_u_dadda_mul6_fa7_y4, h_u_dadda_mul6_fa6_y4, h_u_dadda_mul6_and_2_4_y0) >> 1) & 0x01;
  h_u_dadda_mul6_and_1_5_y0 = and_gate(a_1, b_5);
  h_u_dadda_mul6_fa9_y2 = (fa(h_u_dadda_mul6_and_1_5_y0, h_u_dadda_mul6_fa1_y2, h_u_dadda_mul6_ha2_y0) >> 0) & 0x01;
  h_u_dadda_mul6_fa9_y4 = (fa(h_u_dadda_mul6_and_1_5_y0, h_u_dadda_mul6_fa1_y2, h_u_dadda_mul6_ha2_y0) >> 1) & 0x01;
  h_u_dadda_mul6_and_4_3_y0 = and_gate(a_4, b_3);
  h_u_dadda_mul6_fa10_y2 = (fa(h_u_dadda_mul6_fa9_y4, h_u_dadda_mul6_fa8_y4, h_u_dadda_mul6_and_4_3_y0) >> 0) & 0x01;
  h_u_dadda_mul6_fa10_y4 = (fa(h_u_dadda_mul6_fa9_y4, h_u_dadda_mul6_fa8_y4, h_u_dadda_mul6_and_4_3_y0) >> 1) & 0x01;
  h_u_dadda_mul6_and_3_4_y0 = and_gate(a_3, b_4);
  h_u_dadda_mul6_and_2_5_y0 = and_gate(a_2, b_5);
  h_u_dadda_mul6_fa11_y2 = (fa(h_u_dadda_mul6_and_3_4_y0, h_u_dadda_mul6_and_2_5_y0, h_u_dadda_mul6_fa2_y2) >> 0) & 0x01;
  h_u_dadda_mul6_fa11_y4 = (fa(h_u_dadda_mul6_and_3_4_y0, h_u_dadda_mul6_and_2_5_y0, h_u_dadda_mul6_fa2_y2) >> 1) & 0x01;
  h_u_dadda_mul6_fa12_y2 = (fa(h_u_dadda_mul6_fa11_y4, h_u_dadda_mul6_fa10_y4, h_u_dadda_mul6_fa2_y4) >> 0) & 0x01;
  h_u_dadda_mul6_fa12_y4 = (fa(h_u_dadda_mul6_fa11_y4, h_u_dadda_mul6_fa10_y4, h_u_dadda_mul6_fa2_y4) >> 1) & 0x01;
  h_u_dadda_mul6_and_5_3_y0 = and_gate(a_5, b_3);
  h_u_dadda_mul6_and_4_4_y0 = and_gate(a_4, b_4);
  h_u_dadda_mul6_and_3_5_y0 = and_gate(a_3, b_5);
  h_u_dadda_mul6_fa13_y2 = (fa(h_u_dadda_mul6_and_5_3_y0, h_u_dadda_mul6_and_4_4_y0, h_u_dadda_mul6_and_3_5_y0) >> 0) & 0x01;
  h_u_dadda_mul6_fa13_y4 = (fa(h_u_dadda_mul6_and_5_3_y0, h_u_dadda_mul6_and_4_4_y0, h_u_dadda_mul6_and_3_5_y0) >> 1) & 0x01;
  h_u_dadda_mul6_and_5_4_y0 = and_gate(a_5, b_4);
  h_u_dadda_mul6_fa14_y2 = (fa(h_u_dadda_mul6_fa13_y4, h_u_dadda_mul6_fa12_y4, h_u_dadda_mul6_and_5_4_y0) >> 0) & 0x01;
  h_u_dadda_mul6_fa14_y4 = (fa(h_u_dadda_mul6_fa13_y4, h_u_dadda_mul6_fa12_y4, h_u_dadda_mul6_and_5_4_y0) >> 1) & 0x01;
  h_u_dadda_mul6_and_0_0_y0 = and_gate(a_0, b_0);
  h_u_dadda_mul6_and_1_0_y0 = and_gate(a_1, b_0);
  h_u_dadda_mul6_and_0_2_y0 = and_gate(a_0, b_2);
  h_u_dadda_mul6_and_4_5_y0 = and_gate(a_4, b_5);
  h_u_dadda_mul6_and_0_1_y0 = and_gate(a_0, b_1);
  h_u_dadda_mul6_and_5_5_y0 = and_gate(a_5, b_5);
  h_u_dadda_mul6_u_rca10_rca_a |= (h_u_dadda_mul6_and_1_0_y0 & 0x01) << 0;
  h_u_dadda_mul6_u_rca10_rca_a |= (h_u_dadda_mul6_and_0_2_y0 & 0x01) << 1;
  h_u_dadda_mul6_u_rca10_rca_a |= (h_u_dadda_mul6_fa3_y2 & 0x01) << 2;
  h_u_dadda_mul6_u_rca10_rca_a |= (h_u_dadda_mul6_fa4_y2 & 0x01) << 3;
  h_u_dadda_mul6_u_rca10_rca_a |= (h_u_dadda_mul6_fa6_y2 & 0x01) << 4;
  h_u_dadda_mul6_u_rca10_rca_a |= (h_u_dadda_mul6_fa8_y2 & 0x01) << 5;
  h_u_dadda_mul6_u_rca10_rca_a |= (h_u_dadda_mul6_fa10_y2 & 0x01) << 6;
  h_u_dadda_mul6_u_rca10_rca_a |= (h_u_dadda_mul6_fa12_y2 & 0x01) << 7;
  h_u_dadda_mul6_u_rca10_rca_a |= (h_u_dadda_mul6_and_4_5_y0 & 0x01) << 8;
  h_u_dadda_mul6_u_rca10_rca_a |= (h_u_dadda_mul6_fa14_y4 & 0x01) << 9;
  h_u_dadda_mul6_u_rca10_rca_b |= (h_u_dadda_mul6_and_0_1_y0 & 0x01) << 0;
  h_u_dadda_mul6_u_rca10_rca_b |= (h_u_dadda_mul6_ha3_y0 & 0x01) << 1;
  h_u_dadda_mul6_u_rca10_rca_b |= (h_u_dadda_mul6_ha4_y0 & 0x01) << 2;
  h_u_dadda_mul6_u_rca10_rca_b |= (h_u_dadda_mul6_fa5_y2 & 0x01) << 3;
  h_u_dadda_mul6_u_rca10_rca_b |= (h_u_dadda_mul6_fa7_y2 & 0x01) << 4;
  h_u_dadda_mul6_u_rca10_rca_b |= (h_u_dadda_mul6_fa9_y2 & 0x01) << 5;
  h_u_dadda_mul6_u_rca10_rca_b |= (h_u_dadda_mul6_fa11_y2 & 0x01) << 6;
  h_u_dadda_mul6_u_rca10_rca_b |= (h_u_dadda_mul6_fa13_y2 & 0x01) << 7;
  h_u_dadda_mul6_u_rca10_rca_b |= (h_u_dadda_mul6_fa14_y2 & 0x01) << 8;
  h_u_dadda_mul6_u_rca10_rca_b |= (h_u_dadda_mul6_and_5_5_y0 & 0x01) << 9;
  h_u_dadda_mul6_u_rca10_out = u_rca10(h_u_dadda_mul6_u_rca10_rca_a, h_u_dadda_mul6_u_rca10_rca_b);
  h_u_dadda_mul6_u_rca10_ha_y0 = ((h_u_dadda_mul6_u_rca10_out >> 0) & 0x01);
  h_u_dadda_mul6_u_rca10_fa1_y2 = ((h_u_dadda_mul6_u_rca10_out >> 1) & 0x01);
  h_u_dadda_mul6_u_rca10_fa2_y2 = ((h_u_dadda_mul6_u_rca10_out >> 2) & 0x01);
  h_u_dadda_mul6_u_rca10_fa3_y2 = ((h_u_dadda_mul6_u_rca10_out >> 3) & 0x01);
  h_u_dadda_mul6_u_rca10_fa4_y2 = ((h_u_dadda_mul6_u_rca10_out >> 4) & 0x01);
  h_u_dadda_mul6_u_rca10_fa5_y2 = ((h_u_dadda_mul6_u_rca10_out >> 5) & 0x01);
  h_u_dadda_mul6_u_rca10_fa6_y2 = ((h_u_dadda_mul6_u_rca10_out >> 6) & 0x01);
  h_u_dadda_mul6_u_rca10_fa7_y2 = ((h_u_dadda_mul6_u_rca10_out >> 7) & 0x01);
  h_u_dadda_mul6_u_rca10_fa8_y2 = ((h_u_dadda_mul6_u_rca10_out >> 8) & 0x01);
  h_u_dadda_mul6_u_rca10_fa9_y2 = ((h_u_dadda_mul6_u_rca10_out >> 9) & 0x01);
  h_u_dadda_mul6_u_rca10_fa9_y4 = ((h_u_dadda_mul6_u_rca10_out >> 10) & 0x01);

  out |= (h_u_dadda_mul6_and_0_0_y0 & 0x01) << 0;
  out |= (h_u_dadda_mul6_u_rca10_ha_y0 & 0x01) << 1;
  out |= (h_u_dadda_mul6_u_rca10_fa1_y2 & 0x01) << 2;
  out |= (h_u_dadda_mul6_u_rca10_fa2_y2 & 0x01) << 3;
  out |= (h_u_dadda_mul6_u_rca10_fa3_y2 & 0x01) << 4;
  out |= (h_u_dadda_mul6_u_rca10_fa4_y2 & 0x01) << 5;
  out |= (h_u_dadda_mul6_u_rca10_fa5_y2 & 0x01) << 6;
  out |= (h_u_dadda_mul6_u_rca10_fa6_y2 & 0x01) << 7;
  out |= (h_u_dadda_mul6_u_rca10_fa7_y2 & 0x01) << 8;
  out |= (h_u_dadda_mul6_u_rca10_fa8_y2 & 0x01) << 9;
  out |= (h_u_dadda_mul6_u_rca10_fa9_y2 & 0x01) << 10;
  out |= (h_u_dadda_mul6_u_rca10_fa9_y4 & 0x01) << 11;
  return out;
}

#include <assert.h>
int main(){
  for (int i = 0; i < 64; i++){
    for (int j = 0; j < 64; j++){
      assert((i * j) == h_u_dadda_mul6(i,j));
    }
  }
  return 0;
}